<!DOCTYPE html>
<html lang="en">

    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <script src="http://code.jquery.com/jquery-1.9.1.js"></script>
        <script src="/js/jquery.msgBox.js" type="text/javascript"></script>
        <script src="/js/jquery.quicksearch.js"></script>

        <link href="/css/msgBoxLight.css" rel="stylesheet" type="text/css">
        <link href="/kickstrap.css" rel="stylesheet" type="text/css">
        <title>AFS Store Hours</title>
    </head>


    <body>
        <div class="store-hours">
            <div class="mainContent">
                <input type="text" class="search" name="search" value="" id="search" placeholder="Search" autofocus />
                <br><br>
                <table>
                    <tr>
                        <th>Name</th>
                        <th style='display:none;'>hidden</th>
                        <th>Monday</th>
                        <th>Tuesday</th>
                        <th>Wednesday</th>
                        <th>Thursday</th>
                        <th>Friday</th>
                        <th>Saturday</th>
                        <th>Sunday</th>
                    </tr>
                    <?php

$db_host = 'localhost';
// $db_user = 'afsshare_admin';
// $db_pwd = 'J4@4U&XIyx#A';

$db_user = 'root';
$db_pwd = 'root';
$database = 'afsshare_shareportal';

$conn = mysqli_connect($db_host, $db_user, $db_pwd, $database);
$table = 'stores';

if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$result = $conn->query(getHoursQuery());

if ($result->num_rows > 0) {
    while ($row = $result->fetch_assoc()) {
        $myStore = $row["store_department_name"] . "_" . $row["store_id"];
        echo "<tr><td class='identifier' id='" . $myStore . "'>" . $row["store_name"] . " (" . $row["store_department_name"] . ")</td><td name='" . $myStore . "' style='display:none;'>"
            . $row["store_name"] . "</td><td>"
            . $row["monday_open"] . " to " . $row["monday_close"] . "</td><td>"
            . $row["tuesday_open"] . " to " . $row["tuesday_close"] . "</td><td>"
            . $row["wednesday_open"] . " to " . $row["wednesday_close"] . "</td><td>"
            . $row["thursday_open"] . " to " . $row["thursday_close"] . "</td><td>"
            . $row["friday_open"] . " to " . $row["friday_close"] . "</td><td>"
            . $row["saturday_open"] . " to " . $row["saturday_close"] . "</td><td>"
            . $row["sunday_open"] . " to " . $row["sunday_close"] . "</td></tr>";
        // echo '<input type="hidden" name="' . $myStore . '" value="' . $row["store_name"] . '">';
    }
} else {echo "0 results";}
$conn->close();
?>
                </table>
            </div>
        </div>
    </body>
    <script>
	$(document).ready(function () {
        var bgColor = $("th").css("background-color");
		$(".identifier").on('touch click', function (e) {
			e.preventDefault();
			var storeName = $("td[name*='" + this.attributes.id.value + "']")[0].innerHTML;
			var storeId = this.attributes.id.value;
			$.msgBox({
				title: "Edit Store Hours",
				content: "Are you sure you want to edit store " + storeName + " hours?",
				type: "confirm",
				buttons: [{
						value: "Continue"
					}, {
						value: "Cancel"
					}
				],
				success: function (result) {
					if (result == "Cancel") {}
					else {
						window.location.href = "/storeHoursDetail?store_id=" + storeId + "&storeName=" + encodeURIComponent(storeName);
					}
				}
			});
		});
		$(".identifier").hover(function () {
			$(this).css("background-color", bgColor);
			$(this).css("color", "#fff");
			$(this).css("cursor", "pointer");
		}, function () {
			$(this).css("background-color", "transparent");
			$(this).css("color", bgColor);
		});
		$(function () {
			$('input#search').quicksearch('table tbody tr');
		});
	});
    </script>

</html>
<?php
function getHoursQuery()
{
    $sql = "SELECT";
    $sql .= "    s.store_id,";
    $sql .= "    store_name,";
    $sql .= "    sd.store_department_name,";
    $sql .= "    sh.monday_open,";
    $sql .= "    sh.monday_close,";
    $sql .= "    sh.tuesday_open,";
    $sql .= "    sh.tuesday_close,";
    $sql .= "    sh.wednesday_open,";
    $sql .= "    sh.wednesday_close,";
    $sql .= "    sh.thursday_open,";
    $sql .= "    sh.thursday_close,";
    $sql .= "    sh.friday_open,";
    $sql .= "    sh.friday_close,";
    $sql .= "    sh.saturday_open,";
    $sql .= "    sh.saturday_close,";
    $sql .= "    sh.sunday_open,";
    $sql .= "    sh.sunday_close";
    $sql .= " FROM";
    $sql .= "    stores s";
    $sql .= " JOIN storehours sh ON";
    $sql .= "    s.store_id = sh.store_id";
    $sql .= " JOIN storedepartment sd ON";
    $sql .= "    sh.store_department_id = sd.store_department_id";
    $sql .= ' WHERE hasSite=1';
    $sql .= " ORDER BY";
    $sql .= "    store_name,";
    $sql .= "    sd.store_department_id";

    return $sql;
}

?>